* pages procedures file
* Andrew Schulman, 12 Humboldt St., Cambridge MA 02140, 617-876-2102
* 11/16/86
* revised 11/18/86:  replaced pack with list while .not. deleted()
* revised 11/19/86:  added check for .not. deleted() before clearing screen
* revised 11/21/86:  no recursion:  pages & caller share variable thisfile
* revised 11/21/86:  any len(line) ok: list off trim(substr(line,1,length))
*                    but added test for field name line
* revised 11/24/86:  added parameter SWITCH_OK:  let calling program
*                    determine if OK to go to another file
* revised 12/7/86:   check if passed a ready-to-go .DBF file; otherwise,
*                    append from SDF text file
* revised 12/8/86:   added printing and changed menu bar
* revised 12/13/86:  pass "messages" instead of parameters
* revised 12/16/86:  added a veritable anthology of printer-checking methods
*                    in procedures PRINT, PRINTSUB, and PRNERROR
* revised 4/27/87:   removed incorrect "loop" statements (thanks, Randy!!!!)
* revised 12/27/87:  code cleanup: using &(field(1)), removed curs_off,blinky
* revised 12/28/87:  added left/right shift, debug expression evaluator
* revised 12/30/87:  removed the anthology of printer-checking techniques
* 12/31/87:			 successfully run under Clipper, and on Mac under McMax,
*					 make some fixes for Quicksilver and dBXL

* needed:  one-line scroll, fix bug if search found in top line

procedure PAGE
parameters FILENAME, MYTOP, DEPTH, START, SHOWPAGE, SHOWRULE, INSTRUCT

********************* unpack INSTRUCT message ***********************
switch_ok = iif('switch_ok' $ INSTRUCT, .T., .F.)
curs_off = iif('curs_off' $ INSTRUCT, .T., .F.)		&& not used anymore

**************************** error checking *************************
if DEPTH + START > 22 .or. START > 22 .or. SHOWPAGE > START .or. ;
   SHOWRULE > START
   do STARTERR with "PAGES won't fit on screen or SHOWPAGE/SHOWRULE" + ;
                    " won't show"
   return
endif
if .not. file(FILENAME)
   do STARTERR with "PAGES can't find " + FILENAME
   return
endif

****************************** definitions ************************
beginkeys = "B" + chr(1)
endkeys = "E" + chr(6)
prevkeys = "P" + chr(5) + chr(18) + chr(127) + chr(15) + chr(45)
nextkeys = "N" + chr(24) + chr(3) + chr(9) + chr(32) + chr(13) + chr(43)
leftkeys = "L" + chr(19) + chr(26)
rightkeys = "R" + chr(4) + chr(2)
* note that dBase III Plus doesn't like left arrow chr(26)
* and that McMax (os()="Macintosh") doesn't know about arrow keys

****************************** set up ******************************
store space(10) to whichpage, phrase, otherfile

msgline = START + DEPTH + 1
@START,0 clear to msgline-2,79
@START,0 say "Working...."

set heading off
del_num = 0

if ".DBF" $ upper(FILENAME)  && if they've passed in ready-to-go .DBF file
   use &FILENAME
   field1 = field(1)
   * must be ready-to-go with no blank lines at end!
else
   use line
   field1 = field(1)
   set safety off
   zap
   set safety on
   append from &FILENAME sdf
   go bottom
   do while len(trim(&field1)) < 1 .and. recno() > 1
      delete
      del_num = del_num + 1
      skip -1
   enddo
*** detab:  but this is just too slow!
*** in Summer '87 Clipper, use STRTRAN(&field1,chr(9)," ")
***   go MYTOP
***   do while .not. eof()
***     do while chr(9) $ &field1
***     	replace &field1 with stuff(&field1, at(chr(9), &field1), 1, " ")
***	  	enddo
***	  	skip
***   enddo
endif

fieldlen=len(&field1)
lstart=1

tot = reccount() - del_num

if tot < 1
   do STARTERR with "File is empty"
   return
endif

page = 1
size = tot + 1 - MYTOP
p = size / DEPTH
q = int(p)
pages = iif(p - q = 0, q, q + 1)
end = iif(size < DEPTH, 1, size - DEPTH + START)
foundit = 0
didsearch = .F.

if SHOWRULE > 0
   @SHOWRULE,0 to SHOWRULE,78 double
endif
@msgline-1,0 to msgline-1,78 double

prompt = iif(pages=1, "", ;
			"P)rev N)ext L)eft R)ight B)egin E)nd S)earch A)gain # ") + ;
         iif(SWITCH_OK, "F)ile ", "") + "T)print Q)uit? "

FILENAME = ""
thisfile = ""
* FILENAME is pages2's copy of PUBLIC thisfile, declared in calling program
* demo2.prg and passed to pages2 as parameter.  Looks like we have to
* change BOTH because passed as parameter???
* extract from LIST MEMORY:
*    THISFILE    pub   (hidden)  C  ""
*    FILENAME    priv  @  THISFILE
*    THISFILE    priv  C  ""
* dBXL has a problem with this; who cares!

***************************** main loop ***********************************
goto MYTOP
do while .not. eof()
   thispage = "Page " + str(page,2) + " of " + str(pages,2)
   do SHOW_REV with thispage, SHOWPAGE, 66
   if recno() <> MYTOP
      skip
   endif

   ** all the work is done here
   ** nonprocedural list is 20% faster than procedural do-while loop
   ** and there is another 20% improvement when you trim line
   ** if you wanted to show line numbers, you could:
   ** list trim(substr(&field1,1,70)) next DEPTH while .not. deleted()
   if .not. deleted()
      @START,0 clear to msgline-2,79
      @START-1,79        && see Liskin, Adv dBase III, p.286, for why
      list off trim(substr(&field1,lstart,78)) ;
	     next DEPTH while .not. deleted()
   endif

   if foundit > 0
      saverec = min(recno(), tot - 1)
      goto foundit
      set color to N/W+
      @START,1 say trim(&field1)  && why trouble if first few lines?
      set color to
      goto saverec
      foundit = 0
   endif

   do MSG with prompt
   do INK
   which = upper(chr(ink))
   num = val(which)

   beforerec = recno()

   if pages = 1
      do case
         case which $ 'F' .and. SWITCH_OK
            do NEW_FILE
            if len(trim(thisfile)) > 0
               return
            endif
         case which $ 'T'
            do PRINT
         case which $ 'Q'
            do BYE_BYE with '** DONE **'
            return
         otherwise
            do WAIT_MSG with "Only one page"
            do GO_PAGE with 'home'
      endcase
   else
      do case
	     case which $ leftkeys
		 	lstart=lstart-78
			lstart=iif(lstart < 1, 1, lstart)
			do GO_PAGE with 'same'
		 case which $ rightkeys
		    lstart=lstart+78
			lstart=iif(lstart >= fieldlen-78, lstart-78, lstart)
			do GO_PAGE with 'same'
         case which $ beginkeys
            do GO_PAGE with 'begin'
         case which $ endkeys
            do GO_PAGE with 'end'
         case which $ prevkeys
            do GO_PAGE with 'prev'
         case which $ nextkeys
            do GO_PAGE with 'next'
         case which $ 'T'
            do PRINT
	     case which $ '.'
		    do DEBUG
         case num > 0   && it's a page number
            do GO_PAGE with num
         case which $ '#'   && if can't get to page with 1 digit
            do MYACCEPT with "Go to page #", whichpage
            mypage = val(whichpage)
            do GO_PAGE with mypage
         case which $ "SA"
            do SEARCH
         case which $ 'F' .and. SWITCH_OK
            do NEW_FILE
            if len(trim(thisfile)) > 0
               return
            endif
         case which $ 'Q'
            do BYE_BYE with '** DONE **'
            return
         otherwise
            do GO_PAGE with 'same'
      endcase
   endif
enddo
return

*************************** procedures ******************************
proc MYACCEPT
param msg, var
   @msgline,0
   @msgline,len(msg)
   @msgline-1,79
   accept msg to temp
   var = temp
   * var has to be declared PUBLIC
return

proc BYE_BYE
   param sendmessag
   if sendmessag = '** DONE **'
      sendmessag = ""
   endif
   close databases
   FILENAME = sendmessag  && send message back to caller
   thisfile = sendmessag
   @msgline,0
return

proc DEBUG
 	store space(50) to expression
 	do MYACCEPT with "Eval? ", expression
	@msgline,0
	@msgline-1,79
	on error do NOTHING
	? upper(expression) + " = " 
	?? &expression
	wait ""
	on error
	do GO_PAGE with 'same'
return

* dispatcher for several different routines
proc GO_PAGE
param pg
   do case
      case type('pg') = 'N'
         pg = iif(pg <= 1, 1, int(pg))
         goto iif(pg >= pages, end, ((pg - 1) * DEPTH) + MYTOP - iif(pg = 1, 0, 1))
         page = iif(pg >= pages, pages, pg)
      case type('pg') = 'C'
         do case
            case pg = 'begin'
               goto MYTOP
               page = 1
            case pg = 'end'
               goto end
               page = pages
            case pg = 'prev'
               prev = iif(recno() > (DEPTH*2+1), recno()-(DEPTH*2), MYTOP)
               goto prev
               page = iif(page > 1, page - 1, 1)
            case pg = 'next'
               goto iif(eof(), recno() - DEPTH + 1, recno())
               page = iif(page < pages - 1, page + 1, pages)
            case pg = 'same'
               saverec = iif(recno() - DEPTH > 1, recno() - DEPTH, 1)
               goto saverec
               * necessary because list moves record pointer
         endcase
   endcase
return

proc INK
   public ink
   ink = 0
   do while ink = 0
      ink = inkey()
   enddo
return

proc MSG
param msg
   @msgline,0
   @msgline,0 say msg
return

proc NEW_FILE
   saverec = iif(recno() - DEPTH > 1, recno() - DEPTH, 1)
   do MYACCEPT with "New filename to switch to? ", otherfile
   if file(otherfile)
      do MSG with "Switching file..."
      do BYE_BYE with otherfile
      return
      * depends on calling program PUBLIC variable thisfile
      * this way, pages sends message to calling program rather
      * than recursively calling itself as in previous version of PAGES
   else
      do WAIT_MSG with "No such file"
      goto saverec
   endif
return

proc NOTHING
	* for on error
	@ msgline,0
	?? upper(expression) + "????"
return

proc PRINT
   saverec = iif(recno() - DEPTH > 1, recno() - DEPTH, 1)
   prnmsg = iif(pages = 1, "P)rint, or N)o print? ", ;
            "Print A)ll, T)his page, O)ther page(s), or N)one? ")
   do MSG with prnmsg
   do INK
   which = upper(chr(ink))
   do case
      case which = 'A'.or. (pages = 1 .and. which = 'P')
         do PRINTSUB with 'entire_document'
      case which = 'T'
         do GO_PAGE with 'same' && if SEARCH, this page will be off slightly
         skip           && why??
         do PRINTSUB with 'this_page'
      case which = 'O'
         do WAIT_MSG with "Not yet implemented"
      case which = 'N'
         * do nothing
   endcase
   goto saverec
return
* this prints with no header:  give them a chance to put one in??

proc PRINTSUB
param command
   do case
      case command = 'entire_document'
         prmsg = "Printing entire document..."
         prclause = ""
      case command = 'this_page'
         prmsg = "Printing this page..."
         prclause = "next DEPTH while .not. deleted()"
   endcase
   public clipper		&& will be initialized to .F. if not clipper
   if .not. clipper		&& clipper has no version() function?!?!
   	  if "FoxBASE+" $ version() .and. "Rev 2" $ version()
	     printok = iif(sys(13)="READY", .t., .f.)
 	  else
	  	 * maybe use Quicksilver vars XPRINTON and XPRINTBUSY
		 * maybe use dBXL DOSINT 
	   	 printok = .t.	&& we'll have to assume it's okay!
	  endif
   else
      printok = .t.		&& we'll have to assume it's okay!
   endif
   if printok
      do MSG with prmsg
      set console off
	  *QSOFF
      list off trim(substr(&field1,lstart,78)) &prclause to print
	  *QSON
      eject
      set console on
   else
      ?? chr(7)
      do WAIT_MSG with "Printer not ready"
   endif
return

proc SEARCH
   if which = 'S'
      do MYACCEPT with "Search for ", phrase
   endif
   if which = 'S' .or. (which = 'A' .and. didsearch)
      do MSG with "Searching for " + phrase + "..."
   endif
   saverec = iif(recno() - DEPTH > 1, recno() - DEPTH, 1)
   if .not. eof()
      goto saverec + 1
   endif
   if which = 'S'
      locate for at(upper(phrase), upper(&field1)) > 0
      didsearch = .T.
   else
   	  if which = 'A'
      	 if didsearch
         	continue
		 else
         	do WAIT_MSG with "Must do SEARCH before REPEAT"
		 endif
	  endif
   endif
   **** replaced do-while loop with locate/continue
   if .not. found()
      if didsearch
         do WAIT_MSG with "Not found"
      endif
      goto saverec
   else
      foundit = recno()
      skip -1 && back up so they can see it
      page = int(((recno() - MYTOP) / DEPTH) + 1)
   endif
return

proc STARTERR
param msg
   ?? chr(7)
   @START,0 say msg
   do BYE_BYE with '** DONE **'
return

proc SHOW_REV
param msg, row, col
   @row,col
   @row,col get msg
   clear gets
return

proc WAIT_MSG
param msg
   @msgline,0
   @msgline,len(msg)+32
   @msgline-1,79
   wait msg + " ... Press any key to continue "
   @msgline,0
return

** missing:  need procedure INVAL_SCR to see if screen really needs to
** be redrawn.  Right now, redraws each time through main loop, even if
** nothing has changed.

** if you're examining source code from within PAGES, please remember to
** return to file called PAGES.DAT

